# 
# This file created by olegen.rb
#    ruby olegen.rb 'Microsoft XML, version 2.0'
# 
require 'win32ole'

# 
module IXMLDOMImplementation
  include WIN32OLE::VARIANT
  attr_reader :lastargs

  # 
  def hasFeature(arg0, arg1)
    ret = _invoke(145, [arg0, arg1], [VT_BSTR, VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end
end

# Core DOM node interface
module IXMLDOMNode
  include WIN32OLE::VARIANT
  attr_reader :lastargs

  # insert a child node
  def insertBefore(arg0, arg1)
    ret = _invoke(13, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # replace a child node
  def replaceChild(arg0, arg1)
    ret = _invoke(14, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # remove a child node
  def removeChild(arg0)
    ret = _invoke(15, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # append a child node
  def appendChild(arg0)
    ret = _invoke(16, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def hasChildNodes()
    ret = _invoke(17, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def cloneNode(arg0)
    ret = _invoke(19, [arg0], [VT_BOOL])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree
  def transformNode(arg0)
    ret = _invoke(28, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectNodes(arg0)
    ret = _invoke(29, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectSingleNode(arg0)
    ret = _invoke(30, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree, returning the result through a document or a stream
  def transformNodeToObject(arg0, arg1)
    ret = _invoke(35, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end
end

# 
module IXMLDOMNodeList
  include WIN32OLE::VARIANT
  attr_reader :lastargs

  # get next node from iterator
  def nextNode()
    ret = _invoke(76, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # reset the position of iterator
  def reset()
    ret = _invoke(77, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end
end

# 
module IXMLDOMNamedNodeMap
  include WIN32OLE::VARIANT
  attr_reader :lastargs

  # lookup item by name
  def getNamedItem(arg0)
    ret = _invoke(83, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # set item by name
  def setNamedItem(arg0)
    ret = _invoke(84, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # remove item by name
  def removeNamedItem(arg0)
    ret = _invoke(85, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # lookup the item by name and namespace
  def getQualifiedItem(arg0, arg1)
    ret = _invoke(87, [arg0, arg1], [VT_BSTR, VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # remove the item by name and namespace
  def removeQualifiedItem(arg0, arg1)
    ret = _invoke(88, [arg0, arg1], [VT_BSTR, VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # get next node from iterator
  def nextNode()
    ret = _invoke(89, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # reset the position of iterator
  def reset()
    ret = _invoke(90, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end
end

# 
module IXMLDOMDocument
  include WIN32OLE::VARIANT
  attr_reader :lastargs

  # insert a child node
  def insertBefore(arg0, arg1)
    ret = _invoke(13, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # replace a child node
  def replaceChild(arg0, arg1)
    ret = _invoke(14, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # remove a child node
  def removeChild(arg0)
    ret = _invoke(15, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # append a child node
  def appendChild(arg0)
    ret = _invoke(16, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def hasChildNodes()
    ret = _invoke(17, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def cloneNode(arg0)
    ret = _invoke(19, [arg0], [VT_BOOL])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree
  def transformNode(arg0)
    ret = _invoke(28, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectNodes(arg0)
    ret = _invoke(29, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectSingleNode(arg0)
    ret = _invoke(30, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree, returning the result through a document or a stream
  def transformNodeToObject(arg0, arg1)
    ret = _invoke(35, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create an Element node
  def createElement(arg0)
    ret = _invoke(41, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create a DocumentFragment node
  def createDocumentFragment()
    ret = _invoke(42, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create a text node
  def createTextNode(arg0)
    ret = _invoke(43, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create a comment node
  def createComment(arg0)
    ret = _invoke(44, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create a CDATA section node
  def createCDATASection(arg0)
    ret = _invoke(45, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create a processing instruction node
  def createProcessingInstruction(arg0, arg1)
    ret = _invoke(46, [arg0, arg1], [VT_BSTR, VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create an attribute node
  def createAttribute(arg0)
    ret = _invoke(47, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create an entity reference node
  def createEntityReference(arg0)
    ret = _invoke(49, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # build a list of elements by name
  def getElementsByTagName(arg0)
    ret = _invoke(50, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create a node of the specified node type and name
  def createNode(arg0, arg1, arg2)
    ret = _invoke(54, [arg0, arg1, arg2], [VT_VARIANT, VT_BSTR, VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # retrieve node from it's ID
  def nodeFromID(arg0)
    ret = _invoke(56, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # load document from the specified XML source
  def load(arg0)
    ret = _invoke(58, [arg0], [VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # abort an asynchronous download
  def abort()
    ret = _invoke(62, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # load the document from a string
  def loadXML(arg0)
    ret = _invoke(63, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # save the document to a specified desination
  def save(arg0)
    ret = _invoke(64, [arg0], [VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end
end

# 
module IXMLDOMDocumentType
  include WIN32OLE::VARIANT
  attr_reader :lastargs

  # insert a child node
  def insertBefore(arg0, arg1)
    ret = _invoke(13, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # replace a child node
  def replaceChild(arg0, arg1)
    ret = _invoke(14, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # remove a child node
  def removeChild(arg0)
    ret = _invoke(15, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # append a child node
  def appendChild(arg0)
    ret = _invoke(16, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def hasChildNodes()
    ret = _invoke(17, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def cloneNode(arg0)
    ret = _invoke(19, [arg0], [VT_BOOL])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree
  def transformNode(arg0)
    ret = _invoke(28, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectNodes(arg0)
    ret = _invoke(29, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectSingleNode(arg0)
    ret = _invoke(30, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree, returning the result through a document or a stream
  def transformNodeToObject(arg0, arg1)
    ret = _invoke(35, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end
end

# 
module IXMLDOMElement
  include WIN32OLE::VARIANT
  attr_reader :lastargs

  # insert a child node
  def insertBefore(arg0, arg1)
    ret = _invoke(13, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # replace a child node
  def replaceChild(arg0, arg1)
    ret = _invoke(14, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # remove a child node
  def removeChild(arg0)
    ret = _invoke(15, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # append a child node
  def appendChild(arg0)
    ret = _invoke(16, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def hasChildNodes()
    ret = _invoke(17, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def cloneNode(arg0)
    ret = _invoke(19, [arg0], [VT_BOOL])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree
  def transformNode(arg0)
    ret = _invoke(28, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectNodes(arg0)
    ret = _invoke(29, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectSingleNode(arg0)
    ret = _invoke(30, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree, returning the result through a document or a stream
  def transformNodeToObject(arg0, arg1)
    ret = _invoke(35, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # look up the string value of an attribute by name
  def getAttribute(arg0)
    ret = _invoke(99, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # set the string value of an attribute by name
  def setAttribute(arg0, arg1)
    ret = _invoke(100, [arg0, arg1], [VT_BSTR, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # remove an attribute by name
  def removeAttribute(arg0)
    ret = _invoke(101, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # look up the attribute node by name
  def getAttributeNode(arg0)
    ret = _invoke(102, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # set the specified attribute on the element
  def setAttributeNode(arg0)
    ret = _invoke(103, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # remove the specified attribute
  def removeAttributeNode(arg0)
    ret = _invoke(104, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # build a list of elements by name
  def getElementsByTagName(arg0)
    ret = _invoke(105, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # collapse all adjacent text nodes in sub-tree
  def normalize()
    ret = _invoke(106, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end
end

# 
module IXMLDOMAttribute
  include WIN32OLE::VARIANT
  attr_reader :lastargs

  # insert a child node
  def insertBefore(arg0, arg1)
    ret = _invoke(13, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # replace a child node
  def replaceChild(arg0, arg1)
    ret = _invoke(14, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # remove a child node
  def removeChild(arg0)
    ret = _invoke(15, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # append a child node
  def appendChild(arg0)
    ret = _invoke(16, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def hasChildNodes()
    ret = _invoke(17, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def cloneNode(arg0)
    ret = _invoke(19, [arg0], [VT_BOOL])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree
  def transformNode(arg0)
    ret = _invoke(28, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectNodes(arg0)
    ret = _invoke(29, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectSingleNode(arg0)
    ret = _invoke(30, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree, returning the result through a document or a stream
  def transformNodeToObject(arg0, arg1)
    ret = _invoke(35, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end
end

# 
module IXMLDOMDocumentFragment
  include WIN32OLE::VARIANT
  attr_reader :lastargs

  # insert a child node
  def insertBefore(arg0, arg1)
    ret = _invoke(13, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # replace a child node
  def replaceChild(arg0, arg1)
    ret = _invoke(14, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # remove a child node
  def removeChild(arg0)
    ret = _invoke(15, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # append a child node
  def appendChild(arg0)
    ret = _invoke(16, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def hasChildNodes()
    ret = _invoke(17, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def cloneNode(arg0)
    ret = _invoke(19, [arg0], [VT_BOOL])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree
  def transformNode(arg0)
    ret = _invoke(28, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectNodes(arg0)
    ret = _invoke(29, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectSingleNode(arg0)
    ret = _invoke(30, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree, returning the result through a document or a stream
  def transformNodeToObject(arg0, arg1)
    ret = _invoke(35, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end
end

# 
module IXMLDOMText
  include WIN32OLE::VARIANT
  attr_reader :lastargs

  # insert a child node
  def insertBefore(arg0, arg1)
    ret = _invoke(13, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # replace a child node
  def replaceChild(arg0, arg1)
    ret = _invoke(14, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # remove a child node
  def removeChild(arg0)
    ret = _invoke(15, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # append a child node
  def appendChild(arg0)
    ret = _invoke(16, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def hasChildNodes()
    ret = _invoke(17, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def cloneNode(arg0)
    ret = _invoke(19, [arg0], [VT_BOOL])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree
  def transformNode(arg0)
    ret = _invoke(28, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectNodes(arg0)
    ret = _invoke(29, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectSingleNode(arg0)
    ret = _invoke(30, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree, returning the result through a document or a stream
  def transformNodeToObject(arg0, arg1)
    ret = _invoke(35, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # retrieve substring of value
  def substringData(arg0, arg1)
    ret = _invoke(111, [arg0, arg1], [VT_I4, VT_I4])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # append string to value
  def appendData(arg0)
    ret = _invoke(112, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # insert string into value
  def insertData(arg0, arg1)
    ret = _invoke(113, [arg0, arg1], [VT_I4, VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # delete string within the value
  def deleteData(arg0, arg1)
    ret = _invoke(114, [arg0, arg1], [VT_I4, VT_I4])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # replace string within the value
  def replaceData(arg0, arg1, arg2)
    ret = _invoke(115, [arg0, arg1, arg2], [VT_I4, VT_I4, VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # split the text node into two text nodes at the position specified
  def splitText(arg0)
    ret = _invoke(123, [arg0], [VT_I4])
    @lastargs = WIN32OLE::ARGV
    ret
  end
end

# 
module IXMLDOMCharacterData
  include WIN32OLE::VARIANT
  attr_reader :lastargs

  # insert a child node
  def insertBefore(arg0, arg1)
    ret = _invoke(13, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # replace a child node
  def replaceChild(arg0, arg1)
    ret = _invoke(14, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # remove a child node
  def removeChild(arg0)
    ret = _invoke(15, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # append a child node
  def appendChild(arg0)
    ret = _invoke(16, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def hasChildNodes()
    ret = _invoke(17, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def cloneNode(arg0)
    ret = _invoke(19, [arg0], [VT_BOOL])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree
  def transformNode(arg0)
    ret = _invoke(28, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectNodes(arg0)
    ret = _invoke(29, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectSingleNode(arg0)
    ret = _invoke(30, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree, returning the result through a document or a stream
  def transformNodeToObject(arg0, arg1)
    ret = _invoke(35, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # retrieve substring of value
  def substringData(arg0, arg1)
    ret = _invoke(111, [arg0, arg1], [VT_I4, VT_I4])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # append string to value
  def appendData(arg0)
    ret = _invoke(112, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # insert string into value
  def insertData(arg0, arg1)
    ret = _invoke(113, [arg0, arg1], [VT_I4, VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # delete string within the value
  def deleteData(arg0, arg1)
    ret = _invoke(114, [arg0, arg1], [VT_I4, VT_I4])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # replace string within the value
  def replaceData(arg0, arg1, arg2)
    ret = _invoke(115, [arg0, arg1, arg2], [VT_I4, VT_I4, VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end
end

# 
module IXMLDOMComment
  include WIN32OLE::VARIANT
  attr_reader :lastargs

  # insert a child node
  def insertBefore(arg0, arg1)
    ret = _invoke(13, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # replace a child node
  def replaceChild(arg0, arg1)
    ret = _invoke(14, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # remove a child node
  def removeChild(arg0)
    ret = _invoke(15, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # append a child node
  def appendChild(arg0)
    ret = _invoke(16, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def hasChildNodes()
    ret = _invoke(17, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def cloneNode(arg0)
    ret = _invoke(19, [arg0], [VT_BOOL])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree
  def transformNode(arg0)
    ret = _invoke(28, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectNodes(arg0)
    ret = _invoke(29, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectSingleNode(arg0)
    ret = _invoke(30, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree, returning the result through a document or a stream
  def transformNodeToObject(arg0, arg1)
    ret = _invoke(35, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # retrieve substring of value
  def substringData(arg0, arg1)
    ret = _invoke(111, [arg0, arg1], [VT_I4, VT_I4])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # append string to value
  def appendData(arg0)
    ret = _invoke(112, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # insert string into value
  def insertData(arg0, arg1)
    ret = _invoke(113, [arg0, arg1], [VT_I4, VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # delete string within the value
  def deleteData(arg0, arg1)
    ret = _invoke(114, [arg0, arg1], [VT_I4, VT_I4])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # replace string within the value
  def replaceData(arg0, arg1, arg2)
    ret = _invoke(115, [arg0, arg1, arg2], [VT_I4, VT_I4, VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end
end

# 
module IXMLDOMCDATASection
  include WIN32OLE::VARIANT
  attr_reader :lastargs

  # insert a child node
  def insertBefore(arg0, arg1)
    ret = _invoke(13, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # replace a child node
  def replaceChild(arg0, arg1)
    ret = _invoke(14, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # remove a child node
  def removeChild(arg0)
    ret = _invoke(15, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # append a child node
  def appendChild(arg0)
    ret = _invoke(16, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def hasChildNodes()
    ret = _invoke(17, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def cloneNode(arg0)
    ret = _invoke(19, [arg0], [VT_BOOL])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree
  def transformNode(arg0)
    ret = _invoke(28, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectNodes(arg0)
    ret = _invoke(29, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectSingleNode(arg0)
    ret = _invoke(30, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree, returning the result through a document or a stream
  def transformNodeToObject(arg0, arg1)
    ret = _invoke(35, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # retrieve substring of value
  def substringData(arg0, arg1)
    ret = _invoke(111, [arg0, arg1], [VT_I4, VT_I4])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # append string to value
  def appendData(arg0)
    ret = _invoke(112, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # insert string into value
  def insertData(arg0, arg1)
    ret = _invoke(113, [arg0, arg1], [VT_I4, VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # delete string within the value
  def deleteData(arg0, arg1)
    ret = _invoke(114, [arg0, arg1], [VT_I4, VT_I4])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # replace string within the value
  def replaceData(arg0, arg1, arg2)
    ret = _invoke(115, [arg0, arg1, arg2], [VT_I4, VT_I4, VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # split the text node into two text nodes at the position specified
  def splitText(arg0)
    ret = _invoke(123, [arg0], [VT_I4])
    @lastargs = WIN32OLE::ARGV
    ret
  end
end

# 
module IXMLDOMProcessingInstruction
  include WIN32OLE::VARIANT
  attr_reader :lastargs

  # insert a child node
  def insertBefore(arg0, arg1)
    ret = _invoke(13, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # replace a child node
  def replaceChild(arg0, arg1)
    ret = _invoke(14, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # remove a child node
  def removeChild(arg0)
    ret = _invoke(15, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # append a child node
  def appendChild(arg0)
    ret = _invoke(16, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def hasChildNodes()
    ret = _invoke(17, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def cloneNode(arg0)
    ret = _invoke(19, [arg0], [VT_BOOL])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree
  def transformNode(arg0)
    ret = _invoke(28, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectNodes(arg0)
    ret = _invoke(29, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectSingleNode(arg0)
    ret = _invoke(30, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree, returning the result through a document or a stream
  def transformNodeToObject(arg0, arg1)
    ret = _invoke(35, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end
end

# 
module IXMLDOMEntityReference
  include WIN32OLE::VARIANT
  attr_reader :lastargs

  # insert a child node
  def insertBefore(arg0, arg1)
    ret = _invoke(13, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # replace a child node
  def replaceChild(arg0, arg1)
    ret = _invoke(14, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # remove a child node
  def removeChild(arg0)
    ret = _invoke(15, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # append a child node
  def appendChild(arg0)
    ret = _invoke(16, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def hasChildNodes()
    ret = _invoke(17, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def cloneNode(arg0)
    ret = _invoke(19, [arg0], [VT_BOOL])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree
  def transformNode(arg0)
    ret = _invoke(28, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectNodes(arg0)
    ret = _invoke(29, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectSingleNode(arg0)
    ret = _invoke(30, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree, returning the result through a document or a stream
  def transformNodeToObject(arg0, arg1)
    ret = _invoke(35, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end
end

# structure for reporting parser errors
module IXMLDOMParseError
  include WIN32OLE::VARIANT
  attr_reader :lastargs
end

# 
module IXMLDOMNotation
  include WIN32OLE::VARIANT
  attr_reader :lastargs

  # insert a child node
  def insertBefore(arg0, arg1)
    ret = _invoke(13, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # replace a child node
  def replaceChild(arg0, arg1)
    ret = _invoke(14, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # remove a child node
  def removeChild(arg0)
    ret = _invoke(15, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # append a child node
  def appendChild(arg0)
    ret = _invoke(16, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def hasChildNodes()
    ret = _invoke(17, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def cloneNode(arg0)
    ret = _invoke(19, [arg0], [VT_BOOL])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree
  def transformNode(arg0)
    ret = _invoke(28, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectNodes(arg0)
    ret = _invoke(29, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectSingleNode(arg0)
    ret = _invoke(30, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree, returning the result through a document or a stream
  def transformNodeToObject(arg0, arg1)
    ret = _invoke(35, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end
end

# 
module IXMLDOMEntity
  include WIN32OLE::VARIANT
  attr_reader :lastargs

  # insert a child node
  def insertBefore(arg0, arg1)
    ret = _invoke(13, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # replace a child node
  def replaceChild(arg0, arg1)
    ret = _invoke(14, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # remove a child node
  def removeChild(arg0)
    ret = _invoke(15, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # append a child node
  def appendChild(arg0)
    ret = _invoke(16, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def hasChildNodes()
    ret = _invoke(17, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def cloneNode(arg0)
    ret = _invoke(19, [arg0], [VT_BOOL])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree
  def transformNode(arg0)
    ret = _invoke(28, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectNodes(arg0)
    ret = _invoke(29, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectSingleNode(arg0)
    ret = _invoke(30, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree, returning the result through a document or a stream
  def transformNodeToObject(arg0, arg1)
    ret = _invoke(35, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end
end

# XTL runtime object
module IXTLRuntime
  include WIN32OLE::VARIANT
  attr_reader :lastargs

  # insert a child node
  def insertBefore(arg0, arg1)
    ret = _invoke(13, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # replace a child node
  def replaceChild(arg0, arg1)
    ret = _invoke(14, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # remove a child node
  def removeChild(arg0)
    ret = _invoke(15, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # append a child node
  def appendChild(arg0)
    ret = _invoke(16, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def hasChildNodes()
    ret = _invoke(17, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def cloneNode(arg0)
    ret = _invoke(19, [arg0], [VT_BOOL])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree
  def transformNode(arg0)
    ret = _invoke(28, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectNodes(arg0)
    ret = _invoke(29, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectSingleNode(arg0)
    ret = _invoke(30, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree, returning the result through a document or a stream
  def transformNodeToObject(arg0, arg1)
    ret = _invoke(35, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def uniqueID(arg0)
    ret = _invoke(187, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def depth(arg0)
    ret = _invoke(188, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def childNumber(arg0)
    ret = _invoke(189, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def ancestorChildNumber(arg0, arg1)
    ret = _invoke(190, [arg0, arg1], [VT_BSTR, VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def absoluteChildNumber(arg0)
    ret = _invoke(191, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def formatIndex(arg0, arg1)
    ret = _invoke(192, [arg0, arg1], [VT_I4, VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def formatNumber(arg0, arg1)
    ret = _invoke(193, [arg0, arg1], [VT_R8, VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def formatDate(arg0, arg1, arg2=nil)
    ret = _invoke(194, [arg0, arg1, arg2], [VT_VARIANT, VT_BSTR, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def formatTime(arg0, arg1, arg2=nil)
    ret = _invoke(195, [arg0, arg1, arg2], [VT_VARIANT, VT_BSTR, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end
end

# W3C-DOM XML Document
class Microsoft_XMLDOM_1_0
  include WIN32OLE::VARIANT
  attr_reader :lastargs
  attr_reader :dispatch
  attr_reader :clsid
  attr_reader :progid

  def initialize(obj = nil)
    @clsid = "{2933BF90-7B36-11D2-B20E-00C04F983E60}"
    @progid = "Microsoft.XMLDOM.1.0"
    if obj.nil?
      @dispatch = WIN32OLE.new @progid
    else
      @dispatch = obj
    end
  end

  def method_missing(cmd, *arg)
    @dispatch.method_missing(cmd, *arg)
  end

  # insert a child node
  def insertBefore(arg0, arg1)
    ret = @dispatch._invoke(13, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # replace a child node
  def replaceChild(arg0, arg1)
    ret = @dispatch._invoke(14, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # remove a child node
  def removeChild(arg0)
    ret = @dispatch._invoke(15, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # append a child node
  def appendChild(arg0)
    ret = @dispatch._invoke(16, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def hasChildNodes()
    ret = @dispatch._invoke(17, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def cloneNode(arg0)
    ret = @dispatch._invoke(19, [arg0], [VT_BOOL])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree
  def transformNode(arg0)
    ret = @dispatch._invoke(28, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectNodes(arg0)
    ret = @dispatch._invoke(29, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectSingleNode(arg0)
    ret = @dispatch._invoke(30, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree, returning the result through a document or a stream
  def transformNodeToObject(arg0, arg1)
    ret = @dispatch._invoke(35, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create an Element node
  def createElement(arg0)
    ret = @dispatch._invoke(41, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create a DocumentFragment node
  def createDocumentFragment()
    ret = @dispatch._invoke(42, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create a text node
  def createTextNode(arg0)
    ret = @dispatch._invoke(43, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create a comment node
  def createComment(arg0)
    ret = @dispatch._invoke(44, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create a CDATA section node
  def createCDATASection(arg0)
    ret = @dispatch._invoke(45, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create a processing instruction node
  def createProcessingInstruction(arg0, arg1)
    ret = @dispatch._invoke(46, [arg0, arg1], [VT_BSTR, VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create an attribute node
  def createAttribute(arg0)
    ret = @dispatch._invoke(47, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create an entity reference node
  def createEntityReference(arg0)
    ret = @dispatch._invoke(49, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # build a list of elements by name
  def getElementsByTagName(arg0)
    ret = @dispatch._invoke(50, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create a node of the specified node type and name
  def createNode(arg0, arg1, arg2)
    ret = @dispatch._invoke(54, [arg0, arg1, arg2], [VT_VARIANT, VT_BSTR, VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # retrieve node from it's ID
  def nodeFromID(arg0)
    ret = @dispatch._invoke(56, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # load document from the specified XML source
  def load(arg0)
    ret = @dispatch._invoke(58, [arg0], [VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # abort an asynchronous download
  def abort()
    ret = @dispatch._invoke(62, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # load the document from a string
  def loadXML(arg0)
    ret = @dispatch._invoke(63, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # save the document to a specified desination
  def save(arg0)
    ret = @dispatch._invoke(64, [arg0], [VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def ondataavailable()
    ret = @dispatch._invoke(198, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def onreadystatechange()
    ret = @dispatch._invoke(-609, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end
end

# W3C-DOM XML Document (Apartment)
class Microsoft_FreeThreadedXMLDOM_1_0
  include WIN32OLE::VARIANT
  attr_reader :lastargs
  attr_reader :dispatch
  attr_reader :clsid
  attr_reader :progid

  def initialize(obj = nil)
    @clsid = "{2933BF91-7B36-11D2-B20E-00C04F983E60}"
    @progid = "Microsoft.FreeThreadedXMLDOM.1.0"
    if obj.nil?
      @dispatch = WIN32OLE.new @progid
    else
      @dispatch = obj
    end
  end

  def method_missing(cmd, *arg)
    @dispatch.method_missing(cmd, *arg)
  end

  # insert a child node
  def insertBefore(arg0, arg1)
    ret = @dispatch._invoke(13, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # replace a child node
  def replaceChild(arg0, arg1)
    ret = @dispatch._invoke(14, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # remove a child node
  def removeChild(arg0)
    ret = @dispatch._invoke(15, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # append a child node
  def appendChild(arg0)
    ret = @dispatch._invoke(16, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def hasChildNodes()
    ret = @dispatch._invoke(17, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def cloneNode(arg0)
    ret = @dispatch._invoke(19, [arg0], [VT_BOOL])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree
  def transformNode(arg0)
    ret = @dispatch._invoke(28, [arg0], [VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectNodes(arg0)
    ret = @dispatch._invoke(29, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # execute query on the subtree
  def selectSingleNode(arg0)
    ret = @dispatch._invoke(30, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # apply the stylesheet to the subtree, returning the result through a document or a stream
  def transformNodeToObject(arg0, arg1)
    ret = @dispatch._invoke(35, [arg0, arg1], [VT_BYREF|VT_DISPATCH, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create an Element node
  def createElement(arg0)
    ret = @dispatch._invoke(41, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create a DocumentFragment node
  def createDocumentFragment()
    ret = @dispatch._invoke(42, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create a text node
  def createTextNode(arg0)
    ret = @dispatch._invoke(43, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create a comment node
  def createComment(arg0)
    ret = @dispatch._invoke(44, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create a CDATA section node
  def createCDATASection(arg0)
    ret = @dispatch._invoke(45, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create a processing instruction node
  def createProcessingInstruction(arg0, arg1)
    ret = @dispatch._invoke(46, [arg0, arg1], [VT_BSTR, VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create an attribute node
  def createAttribute(arg0)
    ret = @dispatch._invoke(47, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create an entity reference node
  def createEntityReference(arg0)
    ret = @dispatch._invoke(49, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # build a list of elements by name
  def getElementsByTagName(arg0)
    ret = @dispatch._invoke(50, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # create a node of the specified node type and name
  def createNode(arg0, arg1, arg2)
    ret = @dispatch._invoke(54, [arg0, arg1, arg2], [VT_VARIANT, VT_BSTR, VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # retrieve node from it's ID
  def nodeFromID(arg0)
    ret = @dispatch._invoke(56, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # load document from the specified XML source
  def load(arg0)
    ret = @dispatch._invoke(58, [arg0], [VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # abort an asynchronous download
  def abort()
    ret = @dispatch._invoke(62, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # load the document from a string
  def loadXML(arg0)
    ret = @dispatch._invoke(63, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # save the document to a specified desination
  def save(arg0)
    ret = @dispatch._invoke(64, [arg0], [VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def ondataavailable()
    ret = @dispatch._invoke(198, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # 
  def onreadystatechange()
    ret = @dispatch._invoke(-609, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end
end

# IXMLHttpRequest Interface
module IXMLHttpRequest
  include WIN32OLE::VARIANT
  attr_reader :lastargs

  # Open HTTP connection
  def open(arg0, arg1, arg2=nil, arg3=nil, arg4=nil)
    ret = _invoke(1, [arg0, arg1, arg2, arg3, arg4], [VT_BSTR, VT_BSTR, VT_VARIANT, VT_VARIANT, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # Add HTTP request header
  def setRequestHeader(arg0, arg1)
    ret = _invoke(2, [arg0, arg1], [VT_BSTR, VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # Get HTTP response header
  def getResponseHeader(arg0)
    ret = _invoke(3, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # Get all HTTP response headers
  def getAllResponseHeaders()
    ret = _invoke(4, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # Send HTTP request
  def send(arg0=nil)
    ret = _invoke(5, [arg0], [VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # Abort HTTP request
  def abort()
    ret = _invoke(6, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end
end

# XML HTTP Request class.
class Microsoft_XMLHTTP_1
  include WIN32OLE::VARIANT
  attr_reader :lastargs
  attr_reader :dispatch
  attr_reader :clsid
  attr_reader :progid

  def initialize(obj = nil)
    @clsid = "{ED8C108E-4349-11D2-91A4-00C04F7969E8}"
    @progid = "Microsoft.XMLHTTP.1"
    if obj.nil?
      @dispatch = WIN32OLE.new @progid
    else
      @dispatch = obj
    end
  end

  def method_missing(cmd, *arg)
    @dispatch.method_missing(cmd, *arg)
  end

  # Open HTTP connection
  def open(arg0, arg1, arg2=nil, arg3=nil, arg4=nil)
    ret = @dispatch._invoke(1, [arg0, arg1, arg2, arg3, arg4], [VT_BSTR, VT_BSTR, VT_VARIANT, VT_VARIANT, VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # Add HTTP request header
  def setRequestHeader(arg0, arg1)
    ret = @dispatch._invoke(2, [arg0, arg1], [VT_BSTR, VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # Get HTTP response header
  def getResponseHeader(arg0)
    ret = @dispatch._invoke(3, [arg0], [VT_BSTR])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # Get all HTTP response headers
  def getAllResponseHeaders()
    ret = @dispatch._invoke(4, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # Send HTTP request
  def send(arg0=nil)
    ret = @dispatch._invoke(5, [arg0], [VT_VARIANT])
    @lastargs = WIN32OLE::ARGV
    ret
  end

  # Abort HTTP request
  def abort()
    ret = @dispatch._invoke(6, [], [])
    @lastargs = WIN32OLE::ARGV
    ret
  end
end

# XML Data Source Object
class Microsoft_XMLDSO_1_0
  include WIN32OLE::VARIANT
  attr_reader :lastargs
  attr_reader :dispatch
  attr_reader :clsid
  attr_reader :progid

  def initialize(obj = nil)
    @clsid = "{550DDA30-0541-11D2-9CA9-0060B0EC3D39}"
    @progid = "Microsoft.XMLDSO.1.0"
    if obj.nil?
      @dispatch = WIN32OLE.new @progid
    else
      @dispatch = obj
    end
  end

  def method_missing(cmd, *arg)
    @dispatch.method_missing(cmd, *arg)
  end
end

# XMLDocument extends IXML Document.  It is obsolete.  You should use DOMDocument.  This object should not be confused with the XMLDocument property on the XML data island.
class Msxml
  include WIN32OLE::VARIANT
  attr_reader :lastargs
  attr_reader :dispatch
  attr_reader :clsid
  attr_reader :progid

  def initialize(obj = nil)
    @clsid = "{CFC399AF-D876-11D0-9C10-00C04FC99C8E}"
    @progid = "Msxml"
    if obj.nil?
      @dispatch = WIN32OLE.new @progid
    else
      @dispatch = obj
    end
  end

  def method_missing(cmd, *arg)
    @dispatch.method_missing(cmd, *arg)
  end

  # create different types of IXMLElements.
  def createElement(arg0, arg1, arg2=nil)
    ret = @dispatch._invoke(65644, [arg0, arg1, arg2], [VT_VARIANT, VT_VARIANT, VT_BYREF|VT_BYREF|VT_DISPATCH])
    @lastargs = WIN32OLE::ARGV
    ret
  end
end
